Page MenuHomePhabricator

Allow repository cluster bindings to be marked as not "writable", making them read-only
ClosedPublic

Authored by epriestley on Apr 12 2018, 9:08 PM.
Tags
None
Referenced Files
Unknown Object (File)
Thu, Aug 4, 1:57 AM
Unknown Object (File)
Wed, Aug 3, 2:45 PM
Unknown Object (File)
Thu, Jul 14, 10:06 PM
Unknown Object (File)
Jun 30 2022, 6:14 PM
Unknown Object (File)
Jun 14 2022, 3:02 PM
Unknown Object (File)
Jun 13 2022, 11:09 AM
Unknown Object (File)
Jun 3 2022, 10:27 PM
Unknown Object (File)
May 23 2022, 2:29 AM
Subscribers
None

Details

Summary

Depends on D19356. Fixes T10883. Ref T13120.

  • Add a "writable" property to the bindings, defaulting to "true" with a nice dropdown.
  • When selecting hosts, allow callers to request a writable host.
  • If the caller wants a writable host, only return hosts if they're writable.
  • In SVN and Mercurial, we sometimes return only writable hosts when we could return read-only hosts, but figuring out if these request are read-only or read-write is currently tricky. Since these repositories can't really cluster yet, this shouldn't matter too much today.
Test Plan
  • Without any config changes, viewed repositories via web UI and pushed/pulled via SSH and HTTP.
  • Made all nodes in the cluster read-only by disabling "writable", pulled and hit the web UI (worked), tried to push via SSH and HTTP (got errors about read-only).
  • Put everything back, pulled and pushed.

Diff Detail

Repository
rP Phabricator
Lint
Lint Not Applicable
Unit
Tests Not Applicable

Event Timeline

  • Document the slightly fancier cluster contraction process.
This revision is now accepted and ready to land.Apr 12 2018, 9:56 PM
This revision was automatically updated to reflect the committed changes.

See T13611. This was broken by D20775 (September 2019) until D21576 (February 2021).